import { j as s } from "../../../../node_modules/react/jsx-runtime.mjs";
import { create as z, useModal as F, antdModalV5 as G } from "@ebay/nice-modal-react";
import { Modal as H, Checkbox as J } from "antd";
import t from "./index.module.less.mjs";
import { useState as Q, useEffect as K, useContext as U, useCallback as E, useMemo as y } from "react";
import { TableContext as X } from "../../Store/Provide.mjs";
import { genColumnKey as A, columnSort as Y } from "../../utils/index.mjs";
import O from "../../../../node_modules/classnames/index.mjs";
import { DndContext as Z, DragOverlay as _, defaultDropAnimationSideEffects as $ } from "../../../../node_modules/@dnd-kit/core/dist/core.esm.mjs";
import { arrayMove as L, SortableContext as P, verticalListSortingStrategy as ee } from "../../../../node_modules/@dnd-kit/sortable/dist/sortable.esm.mjs";
import se from "./DndItem.mjs";
import { restrictToVerticalAxis as le, restrictToWindowEdges as oe } from "../../../../node_modules/@dnd-kit/modifiers/dist/modifiers.esm.mjs";
import T from "../../../../node_modules/lodash-es/omit.mjs";
import te from "../../../../node_modules/@ant-design/icons/es/icons/RedoOutlined.mjs";
import ae from "../../../../node_modules/@ant-design/icons/es/icons/DragOutlined.mjs";
const ne = {
  sideEffects: $({
    styles: {
      active: {
        opacity: "0.5"
      }
    }
  })
}, ke = z((N) => {
  var S;
  const B = F(), [m, j] = Q(null);
  K(() => {
    console.log("props", N);
  }, [N]);
  const {
    columnsMap: c,
    setColumnsMap: x,
    sortKeyColumns: b,
    setSortKeyColumns: k,
    clearPersistenceStorage: h,
    ...l
  } = U(X);
  K(() => {
    console.log("columnsMap", {
      columnsMap: c,
      setColumnsMap: x,
      sortKeyColumns: b,
      setSortKeyColumns: k,
      clearPersistenceStorage: h,
      ...l
    });
  }, [c]);
  const R = E(() => {
    h == null || h(), x(l.defaultColumnKeyMap);
  }, []), d = y(() => {
    var o, a;
    const e = [];
    return (o = l == null ? void 0 : l.columns) != null && o.length && ((a = l == null ? void 0 : l.columns) == null || a.map(({ key: r, dataIndex: n, ...i }) => {
      const p = A(
        r || n,
        [r || n].filter(Boolean).join("-")
      ), u = c[p || "null"];
      return u.show !== !1 && e.push({
        key: p,
        ...T(i, ["className"]),
        selectable: !1,
        disabled: u.disable === !0
      }), u;
    })), e.sort(Y(c));
  }, [c, l == null ? void 0 : l.columns]), C = (e) => d.findIndex((o) => o.key === e), g = m ? C(m) : -1, M = y(() => {
    const e = [], o = /* @__PURE__ */ new Map();
    return { list: ((r, n) => r.map(({ key: i, dataIndex: p, children: u, ...D }) => {
      var I;
      const v = A(
        i || p,
        [n == null ? void 0 : n.columnKey, D.index].filter(Boolean).join("-")
      ), f = c[v || "null"] || { show: !0 };
      f.show !== !1 && !u && e.push(v);
      const w = {
        key: v,
        ...T(D, ["className"]),
        selectable: !1,
        disabled: f.disable === !0,
        disableCheckbox: typeof f.disable == "boolean" ? f.disable : (I = f.disable) == null ? void 0 : I.checkbox,
        isLeaf: n ? !0 : void 0
      };
      return o.set(i, w), w;
    }))(l == null ? void 0 : l.columns), keys: e, map: o };
  }, [c, l == null ? void 0 : l.columns]), V = (e, o) => {
    const a = { ...c };
    ((n) => {
      const i = { ...a[n] };
      i.show = !e, a[n] = i;
    })(o.key), x({ ...a });
  }, W = E(
    (e, o) => {
      {
        const a = { ...c }, r = L(b, e, o);
        r.forEach((n, i) => {
          a[n] = { ...a[n] || {}, order: i };
        }), x(a), k(r);
      }
    },
    [c, b]
  ), q = y(() => {
    var e, o;
    return m ? ((o = (e = l == null ? void 0 : l.columns) == null ? void 0 : e.find((a) => a.key === m)) == null ? void 0 : o.title) ?? "" : "";
  }, [l == null ? void 0 : l.columns, m]);
  return /* @__PURE__ */ s.jsxs(H, { title: "自定义列", ...G(B), width: 600, footer: !1, children: [
    /* @__PURE__ */ s.jsx("div", { className: t.introduce, children: "选择要在表中显示的可用列。拖动选定的列以对其重新排序。" }),
    /* @__PURE__ */ s.jsxs("div", { className: t.contaiern, children: [
      /* @__PURE__ */ s.jsxs("div", { className: t.block, children: [
        /* @__PURE__ */ s.jsxs("div", { className: t.header, children: [
          /* @__PURE__ */ s.jsx("div", { className: t.title, children: "可用列" }),
          /* @__PURE__ */ s.jsx("div", {})
        ] }),
        /* @__PURE__ */ s.jsx("div", { className: t.body, children: /* @__PURE__ */ s.jsx("ul", { className: t.content, children: (S = M.list) == null ? void 0 : S.map((e) => {
          const o = M.keys.includes(e.key);
          return /* @__PURE__ */ s.jsxs(
            "li",
            {
              className: O(t.item, {
                [t.checked]: !o
              }),
              onClick: () => !e.disabled && V(o, e),
              children: [
                /* @__PURE__ */ s.jsx(J, { checked: o, disabled: e.disabled }),
                /* @__PURE__ */ s.jsx("span", { className: t["content-item-text"], children: e.title })
              ]
            },
            e.key
          );
        }) }) })
      ] }),
      /* @__PURE__ */ s.jsxs("div", { className: t.block, children: [
        /* @__PURE__ */ s.jsxs("div", { className: t.header, children: [
          /* @__PURE__ */ s.jsx("div", { className: t.title, children: "选定的列" }),
          /* @__PURE__ */ s.jsxs("div", { className: t.reset, onClick: R, children: [
            /* @__PURE__ */ s.jsx("div", { children: "重置  " }),
            /* @__PURE__ */ s.jsx(te, {})
          ] })
        ] }),
        /* @__PURE__ */ s.jsx("div", { className: t.body, children: /* @__PURE__ */ s.jsxs(
          Z,
          {
            modifiers: [le, oe],
            onDragStart: ({ active: e }) => {
              e && j(e.id);
            },
            onDragCancel: () => j(null),
            onDragEnd: (e) => {
              j(null);
              const { over: o } = e;
              if (o) {
                const a = C(o.id);
                g !== a && W(g, a);
              }
            },
            children: [
              /* @__PURE__ */ s.jsx(
                P,
                {
                  items: d == null ? void 0 : d.map((e) => e.key),
                  strategy: ee,
                  children: /* @__PURE__ */ s.jsx("ul", { className: t.content, style: { background: "#fff" }, children: d == null ? void 0 : d.map((e) => /* @__PURE__ */ s.jsx(se, { item: e }, e.key)) })
                }
              ),
              /* @__PURE__ */ s.jsx(_, { adjustScale: !1, dropAnimation: ne, children: m ? /* @__PURE__ */ s.jsxs("li", { className: O(t.moveItem), children: [
                /* @__PURE__ */ s.jsx(ae, { className: t.dragIcon }),
                /* @__PURE__ */ s.jsx("span", { className: t["moveItem-text"], children: q })
              ] }) : null })
            ]
          }
        ) })
      ] })
    ] })
  ] });
});
export {
  ke as default
};
